<?php

namespace Drupal\braintree_api\EventSubscriber;

use Drupal\braintree_api\Event\BraintreeApiEvents;
use Drupal\braintree_api\Event\BraintreeApiWebhookEvent;
use Psr\Log\LoggerInterface;
use Symfony\Component\EventDispatcher\EventSubscriberInterface;

class BraintreeApiSubscriber implements EventSubscriberInterface {

  /**
   * The Braintree API logger channel.
   *
   * @var LoggerInterface
   */
  protected $logger;

  public function __construct(LoggerInterface $logger) {
    $this->logger = $logger;
  }

  /**
   * {@inheritdoc}
   */
  public static function getSubscribedEvents() {
    $events[BraintreeApiEvents::WEBHOOK][] = ['processWebhook'];

    return $events;
  }

  /**
   * @param \Drupal\braintree_api\Event\BraintreeApiWebhookEvent $event
   */
  public function processWebhook(BraintreeApiWebhookEvent $event) {
    $webhook_notification = $event->getWebhookNotification();
    if ($webhook_notification->kind == 'check') {
      $this->logger->info(t('A test webhook was received from Braintree.'));
    }
  }


}
